import * as elements from '@yellicode/elements';
import { ClassDefinition, InterfaceDefinition, EnumDefinition, PropertyDefinition, AccessModifier, ParameterDefinition, FunctionDefinition, DecoratorDefinition } from './model';
import * as opts from './options';
export declare class DefinitionBuilder {
    private typeNameProvider;
    constructor(typeNameProvider: elements.TypeNameProvider);
    buildClassDefinition(type: elements.Type, decorators?: DecoratorDefinition[], options?: opts.ClassOptions): ClassDefinition;
    buildInterfaceDefinition(type: elements.Type, options?: opts.InterfaceOptions): InterfaceDefinition;
    buildEnumDefinition(type: elements.Type, options?: opts.EnumOptions): EnumDefinition;
    buildFunctionDefinition(op: elements.Operation, options?: opts.FunctionOptions): FunctionDefinition;
    buildParameterDefinition(p: elements.Parameter, features: opts.ParameterFeatures, optionalityModifier: opts.OptionalityModifier): ParameterDefinition;
    buildPropertyDefinition(property: elements.Property, decorators?: DecoratorDefinition[], options?: opts.PropertyOptions): PropertyDefinition;
    protected static buildImplements(cls: elements.Class, additional: string[] | undefined): string[];
    protected static buildExtends(type: elements.Classifier, additional: string[] | undefined): string[];
    protected static buildDescription(type: elements.Element): string[];
    static getDefaultValue(element: elements.MultiplicityElement, tsTypeName: string | null, defaultValue: elements.ValueSpecification | null, isOptional: boolean, optionalityModifier: opts.OptionalityModifier, initializePrimitiveType?: boolean, initializeArray?: boolean): any | undefined;
    getFullTypeName(typedElement: elements.TypedElement, fallback?: string): string | undefined;
    static getAccessModifierString(visibility: elements.VisibilityKind | null): AccessModifier | undefined;
}
